<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::capabilityAgents::mrm::test::WaitableExceptionEncounteredSender Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents.html">capabilityAgents</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1mrm.html">mrm</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test.html">test</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender.html">WaitableExceptionEncounteredSender</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::capabilityAgents::mrm::test::WaitableExceptionEncounteredSender Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for alexaClientSDK::capabilityAgents::mrm::test::WaitableExceptionEncounteredSender:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender_inherit__map" id="alexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::ExceptionEncountered\lSenderInterface" alt="" coords="5,5,255,57"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::capabilityAgents::mrm::test::WaitableExceptionEncounteredSender:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender_coll__map" id="alexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::ExceptionEncountered\lSenderInterface" alt="" coords="5,5,255,57"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a322951bb67d3030a43a7aa6f19fd4b69"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender.html#a322951bb67d3030a43a7aa6f19fd4b69">sendExceptionEncountered</a> (const std::string &amp;unparsedDirective, <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fc">avsCommon::avs::ExceptionErrorType</a> error, const std::string &amp;message) override</td></tr>
<tr class="separator:a322951bb67d3030a43a7aa6f19fd4b69"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c039b54451e5d9f3ae75dd6b5741f4e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender.html#a0c039b54451e5d9f3ae75dd6b5741f4e">wait</a> (const std::chrono::milliseconds timeout)</td></tr>
<tr class="separator:a0c039b54451e5d9f3ae75dd6b5741f4e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface</a></td></tr>
<tr class="memitem:ac1dbf7f2fcb9bf6f80db974d2c3052e2 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface.html#ac1dbf7f2fcb9bf6f80db974d2c3052e2">~ExceptionEncounteredSenderInterface</a> ()=default</td></tr>
<tr class="separator:ac1dbf7f2fcb9bf6f80db974d2c3052e2 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class=""><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1test_1_1_waitable_exception_encountered_sender.html">WaitableExceptionEncounteredSender</a> is a mock of the <code>ExceptionEncounteredSenderInterface</code> and allows tests to wait for invocations upon those interfaces and inspect the parameters of those invocations. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a322951bb67d3030a43a7aa6f19fd4b69"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a322951bb67d3030a43a7aa6f19fd4b69">&#9670;&nbsp;</a></span>sendExceptionEncountered()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::mrm::test::WaitableExceptionEncounteredSender::sendExceptionEncountered </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>unparsedDirective</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fc">avsCommon::avs::ExceptionErrorType</a>&#160;</td>
          <td class="paramname"><em>error</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>errorDescription</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Send a <code>System::ExceptionEncountered</code> message to AVS.</p>
<dl class="section note"><dt>Note</dt><dd>The implementation of this method MUST return quickly. Failure to do so blocks the processing of subsequent <code>AVSDirectives</code>.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">unparsedDirective</td><td>The unparsed JSON of the directive. </td></tr>
    <tr><td class="paramname">error</td><td>The type of error encountered. </td></tr>
    <tr><td class="paramname">errorDescription</td><td>Additional error details for logging and troubleshooting. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_exception_encountered_sender_interface.html#a44dda76582bf922eb0a64bc9b03cc146">alexaClientSDK::avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface</a>.</p>

</div>
</div>
<a id="a0c039b54451e5d9f3ae75dd6b5741f4e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0c039b54451e5d9f3ae75dd6b5741f4e">&#9670;&nbsp;</a></span>wait()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::capabilityAgents::mrm::test::WaitableExceptionEncounteredSender::wait </td>
          <td>(</td>
          <td class="paramtype">const std::chrono::milliseconds&#160;</td>
          <td class="paramname"><em>timeout</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Allows the caller to wait until an exception has been sent, up to a maximum timeout. Also returns true if an exception has been previously sent which was not waited upon.</p>
<dl class="section return"><dt>Returns</dt><dd>Whether the exception was sent within the specified timeout, or if an exception has been previously sent, which was not waited upon. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/CapabilityAgents/MRM/test/<a class="el" href="_m_r_m_capability_agent_test_8cpp.html">MRMCapabilityAgentTest.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
